Initial working draft of the new replicate algorithm using
[zfs-ubuntu/.git] / zfs-replicate
index 9a6b82e3655d680e2f645c00cd24fe247b4bdbf4..128d051a3489903a0e1d84cc67a76ed5ed61e933 100755 (executable)
-#!/bin/bash
-
-# Author: Carl Baldwin & Alan Pippin
-# Description: This script replicates a given zfs filesystem to a given zfs pool.
-#              This script will keep all snapshots in sync, removing the ones
-#              that have been deleted since the last replicate was performed.
-#              This script will only send the new, or missing, snapshots since
-#              the last replicate was performed.
-
-# In test mode (test=1) commands are echoed, not executed
-test=0
-
-[ $test == 0 ] && exec >> /var/log/zfs/zfs-replicate.log 2>&1
-
-# Usage: zfs-backup [filesystem] [destination_pool]
-# This script has a limitation with children under a given filesystem.
-# You must initially backup the parent filesystems first using this script
-# before backing up any of the children filesystems.
-
-fs=$1
-fs=${fs%/}
-fsname=${1#*/}
-srcpool=${1%%/*}
-srcfs="${srcpool}/$fsname"
-srcfs=${srcfs%/}
-dstpool=$2
-dstfs="${dstpool}/$srcfs"
-dstfs=${dstfs%/}
-nodstsnaps=0
-common=""
-
-if [ $test == 1 ]; then
-  echo "fs: $fs"
-  echo "fsname: $fsname"
-  echo "srcpool: $srcpool"
-  echo "srcfs: $srcfs"
-  echo "dstpool: $dstpool"
-  echo "dstfs: $dstfs"
-fi
+#/bin/bash
+
+# Usage: replicate <hostname> <zfs filesystem>
+remote=$1
+remote_fs=$2
+remote_pool=${2%%/*}
+
+# Set this variable to '1' to use the legacy, non-marker, snapshot diff, replicate script logic
+use_legacy_replicate=0
 
-if ! zpool list -H "$srcpool" >/dev/null 2>&1; then
-  echo >&2 "-E- The source pool, '$srcpool' doesn't seem to exist."
+# Set the name of the local pool used to store the backup of the remote
+local_pool=backups
+
+# Make sure we have valid arguments
+if [[ -z "$remote" ]] || [[ -z "$remote_fs" ]]; then
+  echo "Usage: $0 <hostname> <zfs filesystem>"
   exit 1
 fi
 
-if ! zpool list -H "$dstpool" >/dev/null 2>&1; then
-  echo >&2 "-E- The destination pool, '$dstpool' doesn't seem to exist."
+# Make sure the local pool and local receiving filesystem exist, or print some errors
+if ! zpool list -H "$local_pool" >/dev/null 2>&1; then
+  echo >&2 "-E- The local pool, '$local_pool' doesn't seem to exist."
+  exit 1
+fi
+if ! zfs list "$local_pool/$remote_pool" >/dev/null 2>&1; then
+  echo >&2 "-E- The local filesystem for the remote pool, '$local_pool/$remote_pool' doesn't seem to exist."
+  echo >&2 "    You will need to create this filesystem before this script can replicate your data."
+  echo >&2 "    You can create this filsystem by executing this command: 'zfs create $local_pool/$remote_pool'"
   exit 1
 fi
 
-if ! zfs list -rH -t snapshot "$dstfs" 2>&1 | grep "$dstfs@" > /dev/null 2>&1; then
-  echo >&2 "-W- No snapshots detected on the destination drive for this filesystem"
-  nodstsnaps=1
+# Obtain the zpool guid for the local pool
+local_pool_guid=`zpool get guid $local_pool 2>&1 | grep $local_pool | awk '{ print $3 }'`
+if ! zpool get guid $local_pool > /dev/null 2>&1; then
+  echo >&2 "-E- Unable to extract the guid for the local pool: $local_pool"
+  exit 1
 fi
 
-if [ $nodstsnaps == 0 ]; then
-  zfs list -rH -t snapshot $srcfs | grep "$srcfs@" | awk '{print $1}' > /tmp/source-list
-  zfs list -rH -t snapshot $dstfs | grep "$dstfs@" | sed "s,$dstpool/,," | awk '{print $1}' > /tmp/destination-list
-  diff -u /tmp/source-list /tmp/destination-list | grep -v '^+++' | awk '/^\+/ {print}' | sed "s,^\+,$dstpool/," > /tmp/obsolete-snapshots
-  rm -f /tmp/source-list /tmp/destination-list
-
-  echo >&2 "Removing obsolete backups from the destination pool" 
-  for snapshot in $(cat /tmp/obsolete-snapshots); do
-    echo >&2 "Removing '$snapshot' from destination."
-    [ $test == 0 ] && zfs destroy "$snapshot"
-  done
-
-  echo >&2 "Rolling back to the most recent snapshot on the destination." 
-  [ $test == 0 ] && zfs rollback $(zfs list -rH -t snapshot $dstfs | grep "$dstfs@" | awk '{snap=$1} END {print snap}')
-
-  echo >&2 "Calculating the most recent common snapshot between the two filesystems." 
-  if zfs list -H "$dstfs" > /dev/null 2>&1; then
-    for snap in $(zfs list -rH -t snapshot "$dstfs" | grep "$dstfs@" |
-                    sed 's,.*@,,' | awk '{print$1}'); do
-      if zfs list -rH -t snapshot "$fs" | grep "$fs@" | sed 's,.*@,,' | awk '{print$1}' | grep "^${snap}$" >/dev/null 2>&1; then
-        common=$snap
-      fi  
-    done
-  fi
+# Turn on shell verbosity
+set -x
+
+# Setup our backup marker names
+current_backup_marker=${remote_fs}@current-backup-${local_pool_guid}
+previous_backup_marker=${remote_fs}@previous-backup-${local_pool_guid}
+
+# The ssh connection doesn't find zfs without this.
+zfs=/usr/sbin/zfs
+
+# List the snapshots on the remote machine.
+remote_list=$(mktemp /tmp/replicate.XXXXXX)
+ssh $remote \
+    $zfs list -H -t snapshot |
+    grep ^${remote_fs}@ |
+    awk '{print$1}' > $remote_list
+if [[ $? != 0 ]]; then
+  echo "-E- remote $zfs list command failed"
+  exit 1
 fi
 
-base=$common
-foundcommon=false
-if [ -z "$common" ]; then
-  foundcommon=true
+# List the snapshots on the local machine.
+local_list=$(mktemp /tmp/replicate.XXXXXX)
+$zfs list -H -t snapshot |
+    grep ^${local_pool}/${remote_fs}@ |
+    awk '{gsub(/^${local_pool}./,"",$1); print$1}' > $local_list
+if [[ $? != 0 ]]; then
+  echo "-E- local $zfs list command failed"
+  exit 1
 fi
 
-for snap in $(zfs list -rH -t snapshot "$fs" | grep "$fs@" |
-                sed 's,.*@,,' | awk '{print$1}'); do
-  if [ "$snap" = "$common" ]; then
-    foundcommon=true
-    continue
+if [ $use_legacy_replicate == 0 ]; then
+  # Destroy the current backup marker snapshot on the remote system if it exists
+  grep -q ${current_backup_marker} $remote_list
+  if [ $? == 0 ]; then
+    ssh $remote $zfs destroy ${current_backup_marker} 
+    if [[ $? != 0 ]]; then
+      echo "-E- remote $zfs destroy command failed"
+      exit 1
+    fi
+  fi
+  # Create the current backup marker snapshot on the remote system
+  ssh $remote $zfs snapshot ${current_backup_marker}
+  if [[ $? != 0 ]]; then
+    echo "-E- remote $zfs snapshot command failed"
+    exit 1
   fi
 
-  if $foundcommon; then
-    if [ -z "$base" ]; then
-      echo >&2 "Sending '$fs@$snap'"
-      [ $test == 0 ] && zfs set readonly=on "$dstpool"
-      [ $test == 0 ] && zfs set atime=off "$dstpool"
-      [ $test == 0 ] && zfs set sharenfs=off "$dstpool"
-      [ $test == 0 ] && zfs set mountpoint=legacy "$dstpool"
-      [ $test == 0 ] && zfs send "$fs@$snap" | zfs recv -v "$dstfs"
-    else
-      echo >&2 "Sending '$fs@$base' -> '$fs@$snap'"
-      [ $test == 0 ] && zfs send -i "$fs@$base" "$fs@$snap" | zfs recv -v "$dstfs"
+  # Check to see if the previous backup marker exists in the remote snapshot list.
+  # Check to see if the previous backup marker exists in the local snapshot list.
+  # If the previous backup markers exists, perform an incremental replicate.
+  # Otherwise, perform a full replicate.
+  grep -q ${previous_backup_marker} $remote_list
+  full=$?
+  grep -q ${previous_backup_marker} $local_list
+  full=$(($full || $?))
+
+  if [[ $full == 0 ]]; then
+    ssh $remote $zfs send -R -I${previous_backup_marker} ${current_backup_marker} | 
+        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
+    if [[ $? != 0 ]]; then
+      echo "-E- remote incremental $zfs send command failed"
+      exit 1
+    fi
+  else
+    ssh $remote $zfs send -R ${current_backup_marker} |
+        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
+    if [[ $? != 0 ]]; then
+      echo "-E- remote full $zfs send command failed"
+      exit 1
     fi
-    base=$snap
   fi
-done
+  # destroy the previous backup markers now that we've replicated past them
+  $zfs destroy ${local_pool}/${previous_backup_marker} > /dev/null 2>&1
+  ssh $remote $zfs destroy ${previous_backup_marker} > /dev/null 2>&1
+
+  # Rename the current backup marker to be the previous backup marker
+  $zfs rename ${local_pool}/${current_backup_marker} ${local_pool}/${previous_backup_marker}
+  if [[ $? != 0 ]]; then
+    echo "-E- local $zfs rename command failed"
+    exit 1
+  fi
+  ssh $remote $zfs rename ${current_backup_marker} ${previous_backup_marker}
+  if [[ $? != 0 ]]; then
+    echo "-E- remote $zfs rename command failed"
+    exit 1
+  fi
+   
+else
+  # See what the most recent snapshot on the remote end is.
+  latest=$(tail -n 1 $remote_list)
+
+  # I did this to make sure that diff would always display the most recent common
+  # Since we're keying off the context of the diff, we need to ensure we will get context
+  # by injecting a known difference in case no others exist in the lists.
+  echo bogus.remote >> $remote_list
+  echo bogus.local  >> $local_list
+  common=$(diff -u $remote_list $local_list | grep '^ ' | tail -n 1)
+
+  if [ -n "$common" ]; then 
+    # We found a common snapshot
+    ssh $remote $zfs send -R -I${common/*@/@} $latest |
+        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
+  else
+    # We did not find a common snapshot, so send the entire filesystem
+    ssh $remote $zfs send -R $latest |
+        $zfs receive -vF -d ${local_pool}/${remote_fs%/*}
+  fi
+fi
+
+# Remove tmp files
+#rm -f $local_list $remote_list
 
-true